$Id$
-------------------------------------------------------------------

     =========================================================
     Geant4 - an Object-Oriented Toolkit for Simulation in HEP
     =========================================================

    Hadronic physics-list/constructors/hadron_inelastic History
    -----------------------------------------------------------
This file should be used  to briefly summarize all major modifications 
introduced in the code and keeptrack of all tags.

     ----------------------------------------------------------
     * Reverse chronological order (last date on top), please *
     ----------------------------------------------------------
7-Nov-2017, Tatsumi Koi (phys-ctor-hinelastic-V10-03-06) 
- Adding G4HadronPhysicsShieldingLEND

6-Nov-2017, Tatsumi Koi (phys-ctor-hinelastic-V10-03-05) 
- Fix registration of cross section data set in G4HadronPhysicsShielding

16-Oct-2017, Alberto Ribon (phys-ctor-hinelastic-V10-03-04) 
- G4HadronPhysicsFTFQGSP_BERT : fixing trivial compiler warnings
  of the previous tag.

16-Oct-2017, Alberto Ribon (phys-ctor-hinelastic-V10-03-03) 
- G4HadronPhysicsFTFQGSP_BERT : new hadron physics similar to
  G4HadronPhysicsFTFP_BERT, but with QGS fragmentation of strings
  (instead of the Lund string fragmentation).

28-Jul-2017, Andrea Dotti (phys-ctor-hinelastic-V10-03-02)
- Refactoring of QGSP_BERT, QGSP_BIC w/ variants

26-Jul-2017, Andrea Dotti
- Refactoring code of all FTFP_BERT variant, FTF_BIC and QGS_BIC

14-Jul-2017, Andrea Dotti               (phys-ctor-hinelastic-V10-03-01)
- Refactoring of code of FTFP_BERT and register physics builders

09-Feb-2017, Makoto Asai                (phys-ctor-hinelastic-V10-03-00)
- Print-out of the transition energy region between FTFP and BERT 
  in the physics lists FTFP_BERT_HP and G4HadronPhysicsFTFP_BERT_HP
  is made only for the master thread.

07-Dec-2016, Alberto Ribon              (phys-ctor-hinelastic-V10-02-10)
- G4HadronPhysicsFTFP_BERT_HP : changed the transition energy region
  between FTFP and BERT in the physics list FTFP_BERT_HP to [3, 12] GeV,
  exactly as it is now in FTFP_BERT.

01-Dec-2016, Alberto Ribon              (phys-ctor-hinelastic-V10-02-09)
- G4HadronPhysicsFTFP_BERT : changed the transition energy region
  between FTFP and BERT in the physics list FTFP_BERT to [3, 12] GeV
  (for pions, kaons, protons and neutrons; for hyperons, left as it
   has always been, i.e. [2, 6] GeV).

24-Nov-2016, Alberto Ribon              (phys-ctor-hinelastic-V10-02-08)
- G4HadronPhysicsFTFP_BERT : changed the transition energy region
  between FTFP and BERT in the physics list FTFP_BERT : now it is
  between [2, 6] GeV.
	 
18-Nov-2016, Alberto Ribon              (phys-ctor-hinelastic-V10-02-07)
- G4HadronPhysicsFTFP_BERT : changed the transition energy region
  between FTFP and BERT in the physics list FTFP_BERT : now it is
  between the large interval [3, 12] GeV (instead of [4, 5] GeV).

04-Nov-2016, Alberto Ribon              (phys-ctor-hinelastic-V10-02-06)
- Written first draft of the README

17-October-2016 M.Maire   (phys-ctor-hinelastic-V10-02-05)
- add README

12-October-2016 G.Folger  (phys-ctor-hinelastic-V10-02-04)
- replace direct use of aParticleIterator by GetParticleIterator().
  fix required by clang39 on Windows and MAC

30-Aug-2016, V.Ivanchenko               (phys-ctor-hinelastic-V10-02-03)
- G4HadronPhysicsQBBC : use G4 de-excitation for the Bertini cascade 

26-May-2016, A. Ribon                   (phys-ctor-hinelastic-V10-02-02)
- G4HadronPhysicsQGSP_BIC_AllHP : treat only proton with ParticleHP in
  this class, and move the others (deuteron, triton, 3He, alpha) to
  the new class G4IonPhysicsPHP.

06-Apr-2016, A. Ribon                   (phys-ctor-hinelastic-V10-02-01)
- G4HadronPhysicsFTFP_BERT_ATL : created new constructor for ATLAS, similar
  to G4HadronPhysicsFTFP_BERT but with the transition between BERT and FTFP
  in the energy region [9, 12] GeV.

04-Dec-2015, A. Ribon                   (phys-ctor-hinelastic-V10-02-00)
- G4HadronPhysicsQGSP_BIC_AllHP : activate ParticleHP for deuteron,
  triton, He3 and alpha.

05-Nov-2015, A. Ribon                   (phys-ctor-hinelastic-V10-01-05)
- Removed neutron_hp/

03-Nov-2015, A. Ribon                   (phys-ctor-hinelastic-V10-01-04)
- Migrated to ParticleHP

26-Oct-2015, A. Ribon                   (phys-ctor-hinelastic-V10-01-03)
- Fixed mistake in the previous tag: now using the correct class
  G4ComponentGGHadronNucleusXsc instead of the old one
  G4GlauberGribovCrossSection

22-Oct-2015, A. Ribon                   (phys-ctor-hinelastic-V10-01-02)
- Use G4ComponentGGHadronNucleusXsc for the kaon inelastic cross sections
  consistently everywhere (instead of either Chips or Gheisha).
  According to LHCb, this class describes well the charged kaon cross
  section asymmetry.

12-Jun-2015, V.Ivanchenko               (phys-ctor-hinelastic-V10-01-01)
- G4HadronInelasticQBBC - reduced upper limit of Bertini from 12 to 4 GeV;
    use BGG inelastic cross section for pions 

30-Mar-2015, A. Ribon                   (phys-ctor-hinelastic-V10-01-00)
- G4HadronPhysicsFTFP_BERT_TRV: changed the transition region between
  BERT and FTF from [3, 12] GeV to [2, 4] GeV.

07-Nov-2014, P. Arce                    (phys-ctor-hinelastic-V10-00-08)
- Add G4HadronPhysicsQGSP_BIC_AllHP for particle_hp physics list

30-Oct-2014, Andrea Dotti               (phys-ctor-hinelastic-V10-00-07)
- Fix in destructor of G4VHadronPhysics to check validity of pointer. 

30-Oct-2014, Julia Yarba                (phys-ctor-hinelastic-V10-00-06)
- In G4HadronPhysicsNuBeam, adjust bertini-ftf overlap from 7-10GeV to 3-3.5GeV
  (based on stat. study, it's better for light targets)

15-Oct-2014, Gabriele Cosmo             (phys-ctor-hinelastic-V10-00-05)
- Added dependency to 'de_excitation/fission' module in GNUMakefile
  and sources.cmake, now required by INCLXX.

05-Aug-2014, Krzysztof Genser           (phys-ctor-hinelastic-V10-00-04)
- Extended Shielding code to also include ShieldingM variant

28-June-2014, Michael Kelsey            (phys-ctor-hinelastic-V10-00-03)
- Add "if (!tpdata) return;" to all dtors, to avoid segfaults.

03-June-2014, Julia Yarba               (phys-ctor-hinelastic-V10-00-02)
- Include ctor's for NuBeam and Shielding

27-May-2014, Davide Mancusi             (phys-ctor-hinelastic-V10-00-01)
- Modify switching energies and models in HadronPhysicsINCLXX.

29-Jan-2014, Gunter Folger              (phys-ctor-hinelastic-V10-00-00)
- Removed from photolepton_hadron/muon_nuclear from sources.cmake

14-Nov-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-20)
- Use G4NeutronInelasticXS for neutrons in the following physics lists
  (besides QBBC and FTFP_BERT_TRV which already use it):
  FTFP_BERT, FTF_BIC, QGSP_FTFP_BERT, QGSP_BERT, QGSP_BIC, QGS_BIC.

08-Nov-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-19)
- Removed low_energy and added fission to sources.cmake and GNUmakefile.

07-Nov-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-18)
- Removed low_energy and high_energy from sources.cmake and GNUmakefile.

24-Sep-2013, Davide Mancusi             (phys-ctor-hinelastic-V09-06-17)
- Fix a possible null-pointer dereference in HadronPhysicsINCLXX.

22-Jul-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-16)
- Nothing is changed: simply re-propose the previous tag after
  fixing an initialization problem in materials category.

19-Jul-2013, Alberto Ribon		(phys-ctor-hinelastic-V09-06-15)
- Replaced LEP neutron capture (Gheisha cross section and G4LCapture model)
  with G4NeutronCaptureXS (cross section) and G4NeutronRadCapture (model)
  in all physics lists.
- Removed LEP fission (Gheisha cross section and G4LFission model) in
  all physics lists which do not make use of neutron_HP.
  For the HP-based physics lists, used LEP fission only above 19.9 MeV.

18-Jun-2013, Alberto Ribon		(phys-ctor-hinelastic-V09-06-14)
- Re-enable quasiElastic in the signature of the constructors
  (but not in the implementation).

17-Jun-2013, Alberto Ribon		(phys-ctor-hinelastic-V09-06-13)
- Fixed compilation warnings (unused QuasiElastic).

12-Jun-2013, Gunter Folger              (phys-ctor-hinelastic-V09-06-12)
- in G4HadronPhysicsINCLXX.cc initialise pointers to optinal parts of 
   physics to 0 to protect deletion of uninitialised pointer.

11-Jun-2013, Alberto Ribon		(phys-ctor-hinelastic-V09-06-11)
- Improved use of kaon cross sections in G4HadronPhysicsShielding. 

09-Jun-2013, Andrea Dotti		(phys-ctor-hinelastic-V09-06-10)
- Fix for MT, make private data members TLS. 

29-Mar-2013, Andrea Dotti		(phys-ctor-hinelastic-V09-06-09)
- Changes needed for MT: now G4VUserPhysicsList is a split class

19-Mar-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-08)
- Fixed quasi-elastic treatment (on for QGS; off for FTF) of the
  previous tag.

19-Mar-2013, Alberto Ribon              (phys-ctor-hinelastic-V09-06-07)
- Replaced LEP with FTFP+BERT in all inelastic physics constructors.
- Depends on phys-builders-V09-06-05.

08-Mar-2013, Davide Mancusi             (phys-ctor-hinelastic-V09-06-06)
- Fix problem with overlapping model ranges.
- Depends on phys-builders-V09-06-03.

04-Mar-2013, Davide Mancusi             (phys-ctor-hinelastic-V09-06-05)
- Fix file/class name mismatch.

04-Mar-2013, Davide Mancusi             (phys-ctor-hinelastic-V09-06-04)
- Parametrized the INCL++ physics constructor to avoid code duplication for
  each INCL++-based physics list.

27-Feb-2013, Vladimir Ivanchenko        (phys-ctor-hinelastic-V09-06-03)
- G4HadronPhysicsFTFP_BERT, G4HadronPhysicsFTFP_BERT_HP - comment out
    unused members of the class to fix warning from the clang compiler 
    on MacOS

22-Feb-2013, Davide Mancusi             (phys-ctor-hinelastic-V09-06-02)
- Modified constructor for QGSP_INCLXX to use PreCompound in nucleon-induced
  reactions below 2 MeV.
- Depends on tag phys-builders-V09-06-02.

08-Feb-2013, Vladimir Ivanchenko        (phys-ctor-hinelastic-V09-06-01)
- GNUmakefile fixed - G4LIB_BUILD_EXPAT is added

10-Jan-2012, Gunter Folger              (phys-ctor-hinelastic-V09-06-00)
- new directory structure introduced. 
   constructors/hadron_inelastic classes
